# spec for build applespi as dkms
# to source applespi-0.1.tar.xz
#[core]
#	repositoryformatversion = 0
#	filemode = true
#	bare = false
#	logallrefupdates = true
#[remote "origin"]
#	url = https://github.com/roadrunner2/macbook12-spi-driver/tree/touchbar-driver-hid-driver
#	fetch = +refs/heads/*:refs/remotes/origin/*
#[branch "touchbar-driver-hid-driver"]
#	remote = origin
#	merge = refs/heads/touchbar-driver-hid-driver
################
# here preloaded modules
%define	modulep1 intel_lpss_pci
%define	modulep2 spi_pxa2xx_platform
%define	modulep3 spi_pxa2xx_pci
# here builded and used
%define	module1 applespi
%define	module2 apple-ibridge
%define	module3 apple-ib-tb
%define	module4 apple-ib-als

%global	module	apple
%global pname applespi

Name:		dkms-%{pname}
Version:	0.1
Release:	%mkrel 4
Source0:	%{pname}-%{version}.tar.xz
Group:		System/Kernel and hardware
License:	GPLv2
URL:		https://github.com/roadrunner2/macbook12-spi-driver/tree/touchbar-driver-hid-driver
Summary:	input driver for the SPI touchpad / keyboard / Touchbar found in MackBooks
Requires:   gcc >= 9.2.0

####Patch0:		spi-debug.patch

BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot
Provides:	kmod(%{module}.ko) = %{version}
Requires(post):		dkms
Requires(preun):	dkms

Obsoletes:	dkms-%{pname} < %{version}-%{release}

%description
This dkms should work with kernel-5.1.10-pclos1!
WIP input driver for the SPI touchpad / keyboard found in the 12" MacBook
(MacBook8,1 + MacBook9,1) and 2016 Macbook Pro (MacBookPro13,*);
a Touchbar driver is also available. 

If you're on any MacBook or MacBook Pro other than MacBook8,1 (2015),
and you're running a kernel before 4.11, then you'll need to boot the kernel
with intremap=nosid.
In all cases make sure you don't have noapic in your kernel options.
!!! read more in documantation /usr/share/doc/appleMBs/allMacBooks-expected-8.1 !!!
On the 2015 MacBook you need to (re)compile your kernel with
CONFIG_X86_INTEL_LPSS=n if running a kernel before 4.14.
And on all kernels you need ensure the spi_pxa2xx_platform and spi_pxa2xx_pci
modules are loaded too (if you don't have those module, rebuild your kernel with
CONFIG_SPI_PXA2XX=m and CONFIG_SPI_PXA2XX_PCI=m).
hint: read more in documantation /usr/share/doc/appleMBs/*

If you're on a MacBook8,1 (2015):read and follow in
documantation /usr/share/doc/appleMBs/MacBooks8.1

On all other MacBook's and MacBook Pros you need to instead make sure both the
spi_pxa2xx_platform and intel_lpss_pci modules are loaded
(if these don't exist, you need to (re)compile your kernel with
CONFIG_SPI_PXA2XX=m and CONFIG_MFD_INTEL_LPSS_PCI=m).
This is correct on this dkms, should work with kernel-5.1.10-pclos1!
apple-ib-als disabled, ambient-light-sensor

%prep
%setup -qn %{pname}-%{version}
find -type f -exec chmod 0644 {} \;

%apply_patches

%install
%__rm -rf %{buildroot}
%__install -dm755 %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__cp -a ./* %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
###%__rm -f %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/{CONTRIBUTORS.md,LICENSE,README.md}
%__install -dm755 %{buildroot}%{_docdir}/appleMBs
%__mv %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/docs/* %{buildroot}/%{_docdir}/appleMBs/
%__rm -rf %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/docs
### create new dkms.conf ###
%__rm -f %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/dkms.conf
%__cat <<EOF > %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/dkms.conf
PACKAGE_NAME=%{pname}
PACKAGE_VERSION=%{version}-%{release}
CLEAN="'make' clean"
MAKE="'make' SKIP_STACK_VALIDATION=1 all"
BUILT_MODULE_NAME[0]="applespi"
BUILT_MODULE_NAME[1]="apple-ibridge"
BUILT_MODULE_NAME[2]="apple-ib-tb"
BUILT_MODULE_LOCATION[0]="./"
BUILT_MODULE_LOCATION[1]="./"
BUILT_MODULE_LOCATION[2]="./"
DEST_MODULE_LOCATION[0]="/kernel/3rdparty/applespi"
DEST_MODULE_LOCATION[1]="/kernel/3rdparty/applespi"
DEST_MODULE_LOCATION[2]="/kernel/3rdparty/applespi"
AUTOINSTALL="yes"
REMAKE_INITRD="no"
EOF

## disable als for testing
# BUILT_MODULE_NAME[3]="apple-ib-als"
# BUILT_MODULE_LOCATION[3]="./"
# DEST_MODULE_LOCATION[3]="/kernel/3rdparty/applespi"
## ##################

%post -n %{name}
/sbin/modprobe %{modulep1} > /dev/null 2>&1
/sbin/modprobe %{modulep2} > /dev/null 2>&1

/usr/sbin/dkms --rpm_safe_upgrade add -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade build -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade install -m %{pname} -v %{version}-%{release}
true
/sbin/modprobe %{pname}

if [ "$1" = 1 ]; then
/sbin/modprobe %{pname} > /dev/null 2>&1
modp1=`cat /etc/modprobe.preload | grep "%{modulep1}"`
modp2=`cat /etc/modprobe.preload | grep "%{modulep2}"`
if [ "$modp1" != "%{modulep1}" ]; then
echo "%{modulep1}" >> /etc/modprobe.preload
fi
if [ "$modp2" != "%{modulep2}" ]; then
echo "%{modulep2}" >> /etc/modprobe.preload
fi
echo "%{pname}" >> /etc/modprobe.preload
fi

%preun -n %{name}
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{pname} -v %{version}-%{release} --all
true
/sbin/rmmod %{pname}

if [ "$1" = 0 ]; then
/sbin/rmmod %{pname} > /dev/null 2>&1
sed -i '/%{module1}/ d' /etc/modprobe.preload
sed -i '/%{module2}/ d' /etc/modprobe.preload
sed -i '/%{module3}/ d' /etc/modprobe.preload
sed -i '/%{module4}/ d' /etc/modprobe.preload
fi

## remove module-destdir just if it empty ##
## after dkms remove,(user's only deinstall after testing)... ##
## so prevent we not have empty folders in kernel-tree for next mklivecd ##
if [ ! -f /lib/modules/*/kernel/3rdparty/%{pname}/* ]; then
rm -r /lib/modules/*/kernel/3rdparty/%{pname} >/dev/null 2>&1
fi


%clean
%__rm -rf %{buildroot}

%files -n %{name}
%defattr(-,root,root)
%doc %{_docdir}/appleMBs/*
%{_usrsrc}/%{pname}-%{version}-%{release}/*
#%config(noreplace) %{_sysconfdir}/modprobe.d/applespi.conf

%changelog
* Tue Aug 13 2019 tex - 0.1-4pclos2019
- rebuild against updates

* Mon Jul 22 2019 onkelho <oh.quait at gmail.com> 0.1-3pclos2018
- rebuild - test disabled apple-ib-als

* Mon Jul 15 2019 onkelho <oh.quait at gmail.com> 0.1-2pclos2018
- rebuild

* Thu Jun 13 2019 onkelho <oh.quait at gmail.com> 0.1-1pclos2019
- initbuild on PCLinuxOS


